/* $Id: main.c,v 1.2 2001/06/10 12:58:29 masu Exp $
/*--------------------------------------------------------------------
/* Name
/*		main.c
/*
/* Description
/*		structre operator code generator
/*
/* Author(s)
/*		masu / Kiyoshi Masumoto <massun.masumoto@nifty.ne.jp>
/*
/*********************************************************************
/**/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cmdline.h"
#include "sogen.h"


int
main( int argc, char *argv[] )
{
	int is_key_val = 0;
	const char *p_key = "";

	cmdline_parse( argc, argv );

	if ( strcmp( cmdline_get_string_key_val(), "" ) ) {
		/* key type is VALUE */
		p_key      = cmdline_get_string_key_val();
		is_key_val = 1;
	} else if ( strcmp( cmdline_get_string_key_string(), "" ) ) {
		/* key type is STRING */
		p_key      = cmdline_get_string_key_string();
	}

	/* code generate */
	if ( sogen_code_generate( cmdline_get_string_inc_file(),	/* include file name */
							  cmdline_get_string_struct_name(),	/* struct name */
							  p_key,							/* key name */
							  is_key_val						/* key type */
							) ) {
		/* error */
		return 1;
	}

	return 0;
}


