#include <stdio.h>
#include <string.h>
#include "address_mgr.h"

void touch( ADDRESS *p )
{
	p->i_key = p->i_key * 2;
}


/* != 0 : hit */
int condition( ADDRESS *p ) 
{
	if ( (p->i_key) >= 5 ) {
		return 1;
	}
	return 0;
}


int comp( const void *p1, const void *p2 )
{
	if ( ((ADDRESS *)p1)->i_key < ((ADDRESS *)p2)->i_key )
		return 1;
	if ( ((ADDRESS *)p2)->i_key < ((ADDRESS *)p1)->i_key )
		return -1;
	return 0;
}

int
main( void )
{
	ADDRESS	addr;

	addr.i_key = 1;
	strcpy( addr.name, "hoge" );
	address_push_back( &addr );


	addr.i_key = 2;
	strcpy( addr.name, "foo" );
	address_push_back( &addr );


	addr.i_key = 3;
	strcpy( addr.name, "hoge" );
	address_push_back( &addr );

	printf( "member = %d\n", address_size() );

	address_pop_back();

	printf( "member = %d\n", address_size() );

	printf( "member = %d\n", address_size() );
	address_clear();
	printf( "member = %d( clear() )\n", address_size() );


	addr.i_key = 2;
	strcpy( addr.name, "foo" );
	address_push_back( &addr );

	addr.i_key = 3;
	strcpy( addr.name, "hoge" );
	address_push_back( &addr );
	printf( "member = %d\n", address_size() );

	addr.i_key = 12;
	strcpy( addr.name, "hoge12" );
	address_push_back( &addr );

	addr.i_key = 11;
	strcpy( addr.name, "hoge11" );
	address_push_back( &addr );

	addr.i_key = 10;
	strcpy( addr.name, "hoge10" );
	address_push_back( &addr );


	printf( "member = %d\n", address_size() );

	/* search */
	{
		ADDRESS *p_ad;
		int i_ret = address_findfirst( condition, &p_ad );
		printf( "find... \n" );
		printf( "i_ret = %d\n", i_ret );
		while ( i_ret ) {
			printf( "ad.i_key = %d\n", p_ad->i_key );
			i_ret = address_findnext( condition, &p_ad );
		}
	}

	/* sort */
	address_sort();
	{
		unsigned int i;
		for ( i = 0; i < address_size(); i++ ) {
			printf( "sorted : %d\n", address_at( i )->i_key );
		}
	}

	/* sort_by */
	address_sort_by( comp );
	{
		unsigned int i;
		for ( i = 0; i < address_size(); i++ ) {
			printf( "sorted : %d\n", address_at( i )->i_key );
		}
	}

	/* sort */
	address_sort();
	{
		unsigned int i;
		for ( i = 0; i < address_size(); i++ ) {
			printf( "sorted : %d\n", address_at( i )->i_key );
		}
	}


	/* search */
	{
		ADDRESS *p_ad;
		int i_ret = address_findfirst( NULL, &p_ad );
		printf( "find... \n" );
		printf( "i_ret = %d\n", i_ret );
		while ( i_ret ) {
			printf( "ad.i_key = %d\n", p_ad->i_key );
			i_ret = address_findnext( NULL, &p_ad );
		}
	}

	/* bsearch */
	{
		ADDRESS *p_ad;
		addr.i_key = 11;
		p_ad = address_bsearch( &addr );
		if ( p_ad ) {
			printf( "bsearch: i_key = %d, name = %s\n", p_ad->i_key, p_ad->name );
		}
	}

	/* bsearch_by */
	{
		ADDRESS *p_ad;
		addr.i_key = 10;
		p_ad = address_bsearch_by( &addr, comp );
		if ( p_ad ) {
			printf( "bsearch: i_key = %d, name = %s\n", p_ad->i_key, p_ad->name );
		}
	}

	/* transform_if */
	address_transform_if( condition, touch );

	/* sort */
	address_sort();
	{
		unsigned int i;
		for ( i = 0; i < address_size(); i++ ) {
			printf( "sorted : %d\n", address_at( i )->i_key );
		}
	}

	return 0;
}


